hdu 3683 Gomoku (模拟、搜索)

Gomoku

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)

Total Submission(s): 1319    Accepted Submission(s): 328

Problem Description

You are probably not familiar with the title, “Gomoku”, but you must have played it a lot. Gomoku is an abstract strategy board game and is also called Five in a Row, or GoBang. It is traditionally played with go pieces (black and white stones) on a go board
(19x19 intersections). Nowadays, standard chessboard of Gomoku has 15x15 intersections. Black plays first, and players alternate in placing a stone of their color on an empty intersection. The winner is the first player to get an unbroken row of five or more
stones horizontally, vertically, or diagonally.

For convenience, we coordinate the chessboard as illustrated above. The left-bottom intersection is (0,0). And the bottom horizontal edge is x-axis, while the left vertical line is y-axis.

I am a fan of this game, actually. However, I have to admit that I don’t have a sharp mind. So I need a computer program to help me. What I want is quite simple. Given a chess layout, I want to know whether someone can win within 3 moves, assuming both players
are clever enough. Take the picture above for example. There are 31 stones on it already, 16 black ones and 15 white ones. Then we know it is white turn. The white player must place a white stone at (5,8). Otherwise, the black player will win next turn. After
that, however, the white player also gets a perfect situation that no matter how his opponent moves, he will win at the 3rd move.

So I want a program to do similar things for me. Given the number of stones and positions of them, the program should tell me whose turn it is, and what will happen within 3 moves.

Input

The input contains no more than 20 cases.

Each case contains n+1 lines which are formatted as follows.

n

x1 y1 c1

x2 y2 c2

......

xn yn cn

The first integer n indicates the number of all stones. n<=222 which means players have enough space to place stones. Then n lines follow. Each line contains three integers: xi and yi and ci. xi and yi are
coordinates of the stone, and ci means the color of the stone. If ci=0 the stone is white. If ci=1 the stone is black. It is guaranteed that 0<=xi,yi<=14, and ci=0 or 1. No two stones are placed
at the same position. It is also guaranteed that there is no five in a row already, in the given cases.

The input is ended by n=0.

Output

For each test case:

First of all, the program should check whose turn next. Let’s call the player who will move next “Mr. Lucky”. Obviously, if the number of the black stone equals to the number of white, Mr. Lucky is the black player. If the number of the black stone equals to
one plus the numbers of white, Mr. Lucky is the white player. If it is not the first situation or the second, print “Invalid.”

A valid chess layout leads to four situations below:

1)Mr. Lucky wins at the 1st move. In this situation, print :

Place TURN at (x,y) to win in 1 move.

“TURN” must be replaced by “black” or “white” according to the situation and (x,y) is the position of the move. If there are different moves to win, choose the one where x is the smallest. If there are still different moves, choose the one where y is the smallest.

2)Mr. Lucky’s opponent wins at the 2nd move. In this situation, print:

Lose in 2 moves.

3)Mr. Lucky wins at the 3rd move. If so, print:

Place TURN at (x,y) to win in 3 moves.

“TURN” should replaced by “black” or “white”, (x,y) is the position where the Mr. Lucky should place a stone at the 1st move. After he place a stone at (x,y), no matter what his opponent does, Mr. Lucky will win at the 3[sup]rd[sup] step. If there
are multiple choices, do the same thing as described in situation 1.

4)Nobody wins within 3 moves. If so, print:

Cannot win in 3 moves.

Sample Input

31
3 3 1
3 4 0
3 5 0
3 6 0
4 4 1
4 5 1
4 7 0
5 3 0
5 4 0
5 5 1
5 6 1
5 7 1
5 9 1
6 4 1
6 5 1
6 6 0
6 7 1
6 8 0
6 9 0
7 5 1
7 6 0
7 7 1
7 8 1
7 9 0
8 5 0
8 6 1
8 7 0
8 8 1
8 9 0
9 7 1
10 8 0
1
7 7 1
1
7 7 0
0

Sample Output

Place white at (5,8) to win in 3 moves.
Cannot win in 3 moves.
Invalid.

思路:1、判断先手是否能在一步走赢,即是否存在一空白格子使得先手的棋子有连续的5个。

2、判断对手是否存在两个空白格子使得他能够得到连续的5个棋子,因为这样,先手就不能堵住后手。

3、枚举任一空白格子放先手棋子,则只需对手方不存在“一空白格子使得棋子有连续的5个”,且先手方此时有"两个空白格子使得他能够得到连续的5个棋子",则先手胜。(攻防转换)

#include<stdio.h>
#include<math.h>
#include<string.h>
#include<stdlib.h>
#include<algorithm>
using namespace std;
#define N 20
const int inf=0x3fffffff;
const double eps=1e-8;
int xx,yy;
int dx[4]={0,1,1,1};
int dy[4]={1,1,0,-1};
int g[N][N];
int bfs1(int v)  //判断是否存在一个空白格子使棋子连成连续的5个
{
    int i,j,k,x,y,sum;
    for(i=0;i<15;i++)
    {
        for(j=0;j<15;j++)
        {
            if(g[i][j]==-1)
            {
                for(k=0;k<4;k++)
                {
                    x=i+dx[k];
                    y=j+dy[k];
                    sum=1;
                    while(1)
                    {
                        if(x<0||x>=15||y<0||y>=15||g[x][y]!=v)
                            break;
                        sum++;
                        x+=dx[k];
                        y+=dy[k];
                    }
                    x=i-dx[k];
                    y=j-dy[k];
                    while(1)
                    {
                        if(x<0||x>=15||y<0||y>=15||g[x][y]!=v)
                            break;
                        sum++;
                        x-=dx[k];
                        y-=dy[k];
                    }
                    if(sum>=5)
                    {
                        xx=i;yy=j;
                        return 1;
                    }
                }
            }
        }
    }
    return 0;
}
int bfs2(int v) //判断是否存在2个空白格子使棋子连成连续的5个
{
    int i,j,k,x,y,sum,num=0;
    for(i=0;i<15;i++)
    {
        for(j=0;j<15;j++)
        {
            if(g[i][j]==-1)
            {
                for(k=0;k<4;k++)
                {
                    x=i+dx[k];
                    y=j+dy[k];
                    sum=1;
                    while(1)
                    {
                        if(x<0||x>=15||y<0||y>=15||g[x][y]!=v)
                            break;
                        sum++;
                        x+=dx[k];
                        y+=dy[k];
                    }
                    x=i-dx[k];
                    y=j-dy[k];
                    while(1)
                    {
                        if(x<0||x>=15||y<0||y>=15||g[x][y]!=v)
                            break;
                        sum++;
                        x-=dx[k];
                        y-=dy[k];
                    }
                    if(sum>=5)
                    {
                        if(num==1)
                            return 1;
                        num++;
                        break;
                    }
                }
            }
        }
    }
    return 0;
}
int bfs3(int v) //情况3,
{
    int i,j;
    for(i=0;i<15;i++)
    {
        for(j=0;j<15;j++)
        {
            if(g[i][j]==-1)
            {
                g[i][j]=v;
                if(bfs1(1-v)==0&&bfs2(v)==1)
                {
                    xx=i;yy=j;
                    return 1;
                }
                g[i][j]=-1;
            }
        }
    }
    return 0;
}
int main()
{
    int i,n,x,y,d,w,b,val;
    while(scanf("%d",&n),n)
    {
        memset(g,-1,sizeof(g));
        w=b=0;
        for(i=0;i<n;i++)
        {
            scanf("%d%d%d",&x,&y,&d);
            g[x][y]=d;
            if(d==0)
                w++;
            else
                b++;
        }
        if(w>b)
        {
            printf("Invalid.\n");
            continue;
        }
        if(w==b)
            val=1;
        else
            val=0;
        if(bfs1(val))
        {
            if(val==0)
                printf("Place white at (%d,%d) to win in 1 move.\n",xx,yy);
            else
                printf("Place black at (%d,%d) to win in 1 move.\n",xx,yy);
        }
        else if(bfs2(1-val))
            printf("Lose in 2 moves.\n");
        else
        {
            if(bfs3(val))
            {
                if(val==0)
                    printf("Place white at (%d,%d) to win in 3 moves.\n",xx,yy);
                else
                    printf("Place black at (%d,%d) to win in 3 moves.\n",xx,yy);
            }
            else
                printf("Cannot win in 3 moves.\n");
        }
    }
    return 0;
}
时间: 2024-10-14 11:46:09

hdu 3683 Gomoku (模拟、搜索)的相关文章

HDU - 4431 Mahjong (模拟+搜索+哈希+中途相遇)

题目链接 基本思路:最理想的方法是预处理处所有胡牌的状态的哈希值,然后对于每组输入,枚举每种新加入的牌,然后用哈希检验是否满足胡牌的条件.然而不幸的是,由于胡牌的状态数过多(4个眼+一对将),预处理的复杂度太高($O(34^5)$),因此需要想办法优化一下. 我们可以预处理出所有“加上一对将之后可以胡牌”的状态,这样预处理的复杂度就成了$O(34^4)$,在可接受的范围内了.在检验的时候,只需要枚举去掉哪一对将,就可以$O(1)$检验是否能胡牌了(有种中途相遇的感觉),另外两种特殊情况单独判断即

[博弈] hdu 3683 Gomoku

题意: 两个人下五子棋.给你现有棋盘,推断在三步之内的胜负情况. 输出分为几种. 1.棋盘不合法 2.黑或白在第一步赢下在(x,y)点,多个输出x最小的.y最小的. 3.输在第二步 4.黑或白在第三步赢在(x,y)点,多个输出x最小的.y最小的. 5.三步内不分胜负 思路: 首先先推断棋盘是否合法 然后就是须要一个寻找当前我要下黑棋或者白棋在棋盘中我有几个必胜点. 所谓的必胜点就是我下这个位置我能连五子或者以上. 然后就是 1.一步直接赢(我有一个或以上的必胜点) 2.二步直接输(对方有两个以上

HDU 3683 Gomoku (枚举+BFS)

题目大意:给一个五子棋,判断能否在三步内赢棋. 分析: 一步赢棋,枚举下棋位置看是否有5子出现 两步对手赢棋,对手有至少两个位置下棋后可以出现5子 三步赢棋,枚举当前己方下棋点,然后判断会不会出现至少两个位置下棋后可以出现5子,这里还得注意枚举的己方下棋后,对手不能出现(1)的情况. #include <iostream> #include <cstring> using namespace std; int a[20][20]; bool inmap(int x,int y,in

HDU 4937 Lucky Number 搜索

题意: 给你一个数,求在多少种不同的进制下这个数每一位都是3.4.5.6中的一个. 思路: 搜索.枚举这个数在任意进制下的表示,判断是否合法.当数字只有3.4.5.6时,必定有无穷种. 因为数字太大,所以直接枚举必定会超时. 下面有两种剪枝的方法: 1. 先枚举最后一位的情况. 假设数字n在base进制下表示为 a[n]...a[0],即 n = a[0] + a[1]*base^1 + ... + a[n]*base^n. 则 n - a[0] = a[1]*base^1 + ... + a[

HDU 1078 记忆化搜索

FatMouse and Cheese Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 4575 Accepted Submission(s): 1829 Problem Description FatMouse has stored some cheese in a city. The city can be considered as a

hdu 4964 Emmet(模拟)

题目链接:hdu 4964 Emmet 题目大意: 给定语句,按照语法翻译并输出. 解题思路:用递归模拟文法分析,主要注意几点: 括号并且的情况:(fuck)(you) 括号嵌套的情况:((fuck.you)) 优先输出id,然后是class(题目中有说) 乘法的部分:fuck*2>you*3 (每次执行fuck时,you的地方同样被执行了3次) 其他跑出样例基本没问题,具体看代码. #include <cstdio> #include <cstring> #include

HDU 4891 简单模拟

The Great Pan Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)Total Submission(s): 1035    Accepted Submission(s): 355 Problem Description As a programming contest addict, Waybl is always happy to take part in vario

hdu 4194(模拟)

符合三者之一的则不满足规定,求不满足规定的个数.直接模拟. 1.被同一个人审查多次 2.被和自己同一组织的审查 3.被审查次数不等于k 代码如下: 1 /************************************************** 2 * Author : xiaohao Z 3 * Blog : http://www.cnblogs.com/shu-xiaohao/ 4 * Last modified : 2014-06-28 17:36 5 * Filename :

HDU 4903 (模拟+贪心)

Fighting the Landlords Problem Description Fighting the Landlords is a card game which has been a heat for years in China. The game goes with the 54 poker cards for 3 players, where the “Landlord” has 20 cards and the other two (the “Farmers”) have 1